/*
   simple library for sending midi commads over standard serial.
*/
#include <Arduino.h>
#include <inttypes.h>

#define BAUDRATE 31250
//#define BAUDRATE 57600

class Midi {
  private:
    const byte PROGRAM_CHANGE = 0xC0;
    const byte CONTROLLER_CHANGE = 0xB0;
  public:
    void changeController(byte channel, byte ctrl, byte data) {
      Serial1.write(PROGRAM_CHANGE + channel);
      Serial1.write(ctrl);
      Serial1.write(data);
    }

    void changeProgram(byte channel, byte program) {
      Serial1.write(PROGRAM_CHANGE + channel);
      Serial1.write(program);
    }

    void initMidi() {
      setMidiBaudrate();
    }

    void setMidiBaudrate() {
      Serial1.begin(BAUDRATE);
    }

    void sendMidiCommands(byte commands[], byte lengthOfCommands) {
      for (byte i = 0; i < lengthOfCommands; i++) {
        Serial1.write(commands[i]);
      }
    }
};
